//<script>
//****************************************************************
//  2000 Microsoft Corporation. All rights reserved.
//****************************************************************


var visPane     = 0;
var plPane      = 1;
var eqPane      = 2;
var vidPane     = 3;

var currentPane     = 0;

var vidIsRunning    = false;


function OnLoad()
{
    pl.setColumnResizeMode(0, "Stretches");
    pl.setColumnResizeMode(1, "AutoSizeData");

    OnOpenStateChange();
    vidIsRunning ? StartVideo() : EndVideo();
}

function OnOpenStateChange()
{
    if (player.OpenState == osMediaOpen)
    {
        vidIsRunning = (player.currentMedia.ImageSourceWidth > 0);
        SetPane( currentPane );
        UpdateMetadata();
    }
}

function StartVideo()
{
    visEffects.visible  = false;
    bgVis.enabled       = false;
    if (currentPane != eqPane)
    {
        SetPane(vidPane);
    }
}

function EndVideo()
{
    visEffects.visible  = true;
    bgVis.enabled       = true;
    if (currentPane == vidPane)
    {
        SetPane(visPane);
    }
}

function UpdateMetadata()
{
    var artist = player.currentmedia.getiteminfo("author");
    if (artist != "" && player.currentmedia.name != "")
    {
        artist += xVidSptr.value;
    }
    artist += player.currentmedia.name;
    metadata.value = player.status;
    if (metadata.value != "" && artist != "")
    {
        metadata.value += xVidSptr.value;
    }
    metadata.value += artist;

    metadata.scrolling = (metadata.textWidth>metadata.width);
}

function SetPane(newPane)
{
    bgEq.upToolTip = xEqTt.toolTip;
    bgPl.upToolTip = xPlTt.toolTip;
    bgVis.enabled = true;

    switch(newPane)
    {
    case visPane:
        visEffects.visible  = true;
        vid.visible         = false;
        pl.visible          = false;
        sEq.visible         = false;
        bgVis.upToolTip     = xVisTt.value;
        break;
    case plPane:
        pl.visible          = true;
        visEffects.visible  = false;
        sEq.visible         = false;
        vid.visible         = false;
        bgPl.upToolTip      = xPlTt.value;
        bgVis.upToolTip     = vidIsRunning ? xVidSptr.toolTip : xVisTt.toolTip;
        break;
    case eqPane:
        sEq.visible         = true;
        visEffects.visible  = false;
        pl.visible          = false;
        vid.visible         = false;
        bgEq.upToolTip      = xEqTt.value;
        bgVis.upToolTip     = vidIsRunning ? xVidSptr.toolTip : xVisTt.toolTip;
        break;
    case vidPane:
        vid.visible         = true;
        visEffects.visible  = false;
        sEq.visible         = false;
        pl.visible          = false;
        bgVis.upToolTip     = "";
        bgVis.enabled       = false;
        break;
    }

    currentPane = newPane;
}

