//<script>
//****************************************************************
//  2000 Microsoft Corporation. All rights reserved.
//****************************************************************
//
// JScript Editbox Object
//
// This object allows for a windows media player skin to "simulate"
// an edit box using text controls and subviews
//****************************************************************



//****************************************************************
//****************************************************************
//
// editbox object
//
//****************************************************************
//****************************************************************

function editbox( backing_sv, edit_text, ibar_text, focus_button,
                  onTextChange, onEnter )
{
    // Controls
    
    this.backing_sv             = backing_sv;
    this.edit_text              = edit_text;
    this.ibar_text              = ibar_text;
    this.focus_button           = focus_button;

    // Public methods

    this.onEditBoxKeyPressED    = onEditBoxKeyPressED;
    this.onEditBoxKeyDownED     = onEditBoxKeyDownED;
    this.onEditBoxFocusED       = onEditBoxFocusED;
    this.onEditBoxBlurED        = onEditBoxBlurED;
    this.onEditBoxEndMoveED     = onEditBoxEndMoveED;
    this.setTextED              = setTextED;
    
    // Public Events
    
    this.onTextChange           = onTextChange;
    this.onEnter                = onEnter;
    
    
    // Initialization Code

    this.ibar_text.left = this.edit_text.left + this.edit_text.width - 2;
}




//****************************************************************
// XML Callbacks
//****************************************************************

//****************************************************************
// This function is called when a key is pressed in the edit box

function onEditBoxKeyPressED()
{
    var fChange = false;

    switch (event.keyCode)
    {
    case 9:     // tab
        break;

    case 8:     // backspace
    case 37:    // left-arrow

        var str         = new String( this.edit_text.value );
        if (str.length > 0)
        {
            this.edit_text.value = str.substr( 0, str.length - 1 );
            fChange = true;
        }
        break;

    case 13:    // CR

        if (this.onEnter)
        {
            this.onEnter();        
        }
        break;
    
    default:

        var str                 = this.edit_text.value;
        var key                 = String.fromCharCode( event.keyCode );
        this.edit_text.value    = str + key;
        
        // We don't want our text to grow past the length of our
        // backing text
        
        if ((this.edit_text.left + this.edit_text.textWidth + 5) >= this.backing_sv.width)
        {
            this.edit_text.value = str;
        }
        else
        {
            fChange = true;
        }
    }
    
    this.ibar_text.left = this.edit_text.left + this.edit_text.width - 2;
    this.onEditBoxFocusED();
    
    if (fChange && this.onTextChange)
    {
        this.onTextChange();    
    }
}

//****************************************************************
// this function is called from the keydown handler of the edit box

function onEditBoxKeyDownED()
{
    switch (event.keyCode)
    {
    case 37:        // left-arrow

        this.onEditBoxKeyPressED();
        break;
    }
}

//****************************************************************
// this function is called when the edit box receives focus

function onEditBoxFocusED()
{
    this.ibar_text.visible = true;
    this.edit_text.moveTo( this.edit_text.left, this.edit_text.top, 500 );
}

//****************************************************************
// this function is called when the edit box loses focus

function onEditBoxBlurED()
{
    this.ibar_text.visible = false;
}

//****************************************************************
// this function is called to blink the ibar based upon a timer

function onEditBoxEndMoveED()
{
    if (view.focusObjectID == this.focus_button.id)
    {
        this.ibar_text.visible = !this.ibar_text.visible;
        this.edit_text.moveTo( this.edit_text.left, this.edit_text.top, 500 );
    }
}

//****************************************************************
// this function is called to blink the ibar based upon a timer

function setTextED( txt )
{
    this.edit_text.value = txt;
    this.ibar_text.left = this.edit_text.left + this.edit_text.width - 2;
}

